<template>
  <div id="wind-pressure">
    <div class="name">风压</div>
    <div class="list">
      <wind-pressure-item v-for="(item,index) in wpList" :key="item.equipmentId" :wp="item"
                          @click="handleOpenChart(item)"/>
    </div>
    <div class="digital-tunnel">
      <el-dialog :close-on-click-modal="false" v-model="isVisited" :title="windSort+'监控数据'" width="2175px"
                 :modal="false">
        <div class="left-top-icon"></div>
        <div class="right-top-icon"></div>
        <div class="chat-dialog">
          <div id="container"></div>
          <div style="width: 1px;"></div>
        </div>
        <div class="time-select">
          <time-range-btn
              :buttonList="timeList"
              v-model="selectTimeButton"
              @select="timeSelect"
          />
        </div>
        <div class="left-bottom-icon"></div>
        <div class="right-bottom-icon"></div>
      </el-dialog>
    </div>
  </div>
</template>

<script setup>
import WindPressureItem from "./childComps/WindPressureItem.vue";
import TimeRangeBtn from "@/components/timeRangeBtn/index.vue"
import * as echarts from 'echarts';
import {getEchartsInfo} from "@/api/largeScreen";

const props = defineProps({
  list: Array,
  winData: Array
});
const windSort = ref(1)
const timeList = ref(["年", "月", "日"]);
const selectTimeButton = ref(2);
const isVisited = ref(false);
let myEcharts = reactive({});
const wpList = ref([]);
const chartData = ref()
watch(() => props.list, (now) => {
  wpList.value.forEach(item => {
    now.forEach(newItem => {
      if (item.equipmentId === newItem.equipmentId) {
        item.value = newItem.value
      }
    })
  })
}, {deep: true});

watch(() => props.winData, (now) => {
  getScreenInfo(now.windPressureSensorList)
}, {deep: true});

const getWindInfo = (equipmentId) => {
  getEchartsInfo(equipmentId).then(res => {
    if (res?.code === 1000) {
      isVisited.value = true
      nextTick(() => {
        initChart(res.data.dates, res.data.values)
      })
    }
  })
}

const handleOpenChart = (item) => {
  getWindInfo(item.equipmentId)
  windSort.value = item.equipmentName
}
const timeSelect = (index) => {
  console.log('选择时间', index)
  if (index === 0) {
    console.log('--年')
  } else if (index === 1) {
    console.log('--月')
  } else if (index === 2) {
    console.log('--日')
  }
};
const getScreenInfo = (now) => {
  let windPressureObj = {}
  let windPressureArr = []
  now?.map(item => {
    windPressureObj = {
      equipmentId: item.equipmentId,
      equipmentName: item.equipmentName,
      max: 120,
      value: item.value,
      point: item.valueThreshold,
      unit: item.unit
    }
    windPressureArr.push(windPressureObj)
  })
  wpList.value = windPressureArr
}
/**
 * 初始化echarts实例方法
 */
const initChart = (type, values) => {
  //3.初始化container容器
  myEcharts = echarts.init(document.getElementById('container'));
  //5.传入数据
  let option = {
    //图例
    legend: {
      left: 0,
      textStyle: {
        color: '#FFFFFF',
        fontSize: 40
      },
      // itemWidth: 20,
      // itemHeight: 20
    },
    //离容器四侧的距离
    grid: {
      left: 0, // 左边距
      right: 20, // 右边距
      top: 80, // 顶边距
      bottom: 0, // 底边距
      containLabel: true,
    },
    //提示框组件
    tooltip: {
      show: true,
      trigger: 'axis',
      backgroundColor: "transparent", // 设置背景颜色为透明
      borderColor: "transparent", // 设置边框颜色为透明
      padding: 0, // 设置内边距为0
      textStyle: {
        fontSize: 40
      },
      formatter: function (params) {
        let content = `
          <div style="background: linear-gradient(180deg, #254062 0%, rgba(20,36,51,0.3) 100%);;border: 2px solid #6087BA;border-radius: 4px;padding: 8px 16px;">
            <div style="font-size: 52px;font-family: PingFang SC-Regular, PingFang SC;font-weight: 400;color: #EFEEEE;margin-bottom: 8px;">${params[0].name}</div>
            <div style="font-size: 52px;line-height: 48px;font-family: Bebas Neue-Regular, Bebas Neue;font-weight: 400;margin-top: 20px"><span style="background: linear-gradient(180deg, #F5B85F 0%, #FFFFFF 100%);background-clip: text;-webkit-background-clip: text;-webkit-text-fill-color: transparent;">${params[0].value}</span></div>
          </div>`;
        return content;
      },
    },
    toolbox: {
      show: false,
      right: 10,
      feature: {
        dataZoom: {
          yAxisIndex: 'none'
        }
      }
    },
    dataZoom: [{
      type: 'inside'
    }],
    //X轴
    xAxis: {
      type: 'category',
      // data: ['00:00', '01:00', '02:00', '03:00', '04:00', '05:00', '06:00','07:00', '08:00', '09:00', '10:00', '11:00', '12:00', '13:00', '14:00', '15:00', '16:00', '17:00', '18:00','19:00', '20:00', '21:00', '22:00', '23:00','24:00'],
      data: type,
      axisLabel: {
        textStyle: {
          fontSize: 45,
          color: '#D6F1FA'
        },
      },
    },
    //Y轴
    yAxis: {
      type: 'value',
      axisLabel: {
        textStyle: {
          fontSize: 45,
          color: '#D6F1FA'
        },
      },
    },
    //配置项
    series: [
      {
        // data: [56, 12, 89, 34, 71, 43, 67, 20, 98, 72, 19, 61, 3, 85, 47, 92, 17, 76, 69, 25, 31, 49, 81, 63],
        data: values,
        type: 'line',
        smooth: true,
        symbolSize: 24,
        lineStyle: {
          width: 5
        },
      }
    ]
  }
  myEcharts.setOption(option);
  //图表大小自适应窗口大小变化
  window.onresize = () => {
    myEcharts.resize();
  }
}

</script>

<style lang="scss" scoped>
#wind-pressure {
  width: 830px;
  height: 779px;
  position: absolute;
  top: 185px;
  right: 68px;
  background-image: url(../../../assets/images/windPressure/bg.png);
  padding: 22px 17px 0 23px;

  .name {
    width: 64px;
    height: 42px;
    font-size: 32px;
    font-family: MicrosoftYaHei, MicrosoftYaHei;
    font-weight: bold;
    color: #38cafb;
    line-height: 42px;
    margin-left: 62px;
    margin-bottom: 38px;
  }
}
</style>
